%define name	vsftpd
%define version	2.0.3
%define	rel	1
%define	release	%mkrel %{rel}

Summary:	Very Secure File Transfer Protocol Daemon
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		System/Servers
URL:		http://vsftpd.beasts.org/
Source0:	ftp://vsftpd.beasts.org/users/cevans/%{name}-%{version}.tar.bz2
Source1:	vsftpd.xinetd
Source2:	vsftpd.pam
Source3:	vsftpd.ftpusers
Source4:	vsftpd.user_list
Source5:	vsftpd.init
Source6:	vsftpd_conf_migrate.sh
Patch1:		vsftpd-1.1.3-rh.patch.bz2
Patch2:		vsftpd-1.0.1-missingok.patch.bz2
Patch3:		vsftpd-1.2.0-anon.patch.bz2
Patch4:		vsftpd-2.0.1-lib64.patch.bz2
Patch5:		vsftpd-2.0.1-tcp_wrappers.patch.bz2
Patch6:		vsftpd-1.5.1-libs.patch.bz2
Patch7:		vsftpd-2.0.2-signal.patch.bz2
Patch8:		vsftpd-1.2.1-conffile.patch.bz2
Patch9:		vsftpd-2.0.1-build_ssl.patch.bz2
Patch10:	vsftpd-2.0.1-server_args.patch.bz2
Patch11:	vsftpd-2.0.1-dir.patch.bz2
Patch12:	vsftpd-2.0.1-use_localtime.patch.bz2
Patch13:	vsftpd-1.2.1-nonrootconf.patch.bz2
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
PreReq:		rpm-helper
Requires:	xinetd, pam >= 0.59, libcap, openssl, logrotate
Provides:	ftpserver
Conflicts:	wu-ftpd
Conflicts:	proftpd
Conflicts:	ncftpd
Conflicts:	pure-ftpd
BuildRequires:	libcap-devel openssl-devel pam-devel tcp_wrappers-devel

%description
A Very Secure FTP Daemon - written from scratch - by Chris "One Man Security
Audit Team" Evans.

%prep
%setup -q
%patch1   -p1 -b .orig
%patch2   -p1 -b .mok
%patch3   -p1 -b .anon
%patch4   -p1 -b .lib64
cp %{SOURCE1} .
%patch5   -p1 -b .tcp_wrap
%patch6   -p1 -b .libs
%patch7   -p1 -b .signal
%patch8   -p1
%patch9  -p1 -b .build_ssl
%patch10  -p1 -b .servers_args
%patch11  -p1 -b .dir
%patch12  -p1 -b .use_localtime
%patch13  -p1 -b .nonroot


%build
%serverbuild

%make CFLAGS="$RPM_OPT_FLAGS"
# should go to rh patch.
# Change a few defaults in the config:
perl -pi -e 's|#ls_recurse_enable|ls_recurse_enable|' vsftpd.conf
## Fix the /usr/local problem in the xinetd entry
perl -pi -e 's|/usr/local/sbin/vsftpd|%{_sbindir}/vsftpd|' xinetd.d/vsftpd

%install
rm -rf %buildroot

install -m755 vsftpd -D %buildroot%{_sbindir}/vsftpd
install -m600 vsftpd.conf -D %buildroot%{_sysconfdir}/vsftpd/vsftpd.conf
#install -m644 xinetd.d/vsftpd -D %buildroot%{_sysconfdir}/xinetd.d/vsftpd
install -m644 vsftpd.conf.5 -D %buildroot/%{_mandir}/man5/vsftpd.conf.5
install -m644 vsftpd.8 -D %buildroot%{_mandir}/man8/vsftpd.8
install -m644 RedHat/vsftpd.log -D %buildroot%{_sysconfdir}/logrotate.d/vsftpd
install -m644 %{SOURCE2}  -D %buildroot%{_sysconfdir}/pam.d/vsftpd
install -m600 %{SOURCE3}  -D %buildroot%{_sysconfdir}/vsftpd/ftpusers
install -m600 %{SOURCE4}  -D %buildroot%{_sysconfdir}/vsftpd/user_list
install -m 755 %{SOURCE5} -D %buildroot%{_initrddir}/vsftpd
install -m 744 %{SOURCE6} -D %buildroot%{_sysconfdir}/vsftpd/vsftpd_conf_migrate.sh
touch %buildroot%{_sysconfdir}/vsftpd/banned-emails
touch %buildroot%{_sysconfdir}/vsftpd/chroot-list
mkdir -p %buildroot/var/ftp/pub

%post
%_post_service vsftpd
if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

%pre
%_pre_useradd ftp /var/ftp /bin/false

%postun
%_postun_userdel ftp

%preun
%_preun_service vsftpd
if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

%clean
rm -rf %buildroot

%files
%defattr(-, root, root)
%doc FAQ INSTALL BUGS AUDIT Changelog LICENSE README README.security REWARD SPEED TODO 
%doc BENCHMARKS COPYING SECURITY/ EXAMPLE/ TUNING SIZE vsftpd.xinetd
%{_sbindir}/vsftpd
%{_initrddir}/vsftpd
%attr(0555,ftp,ftp) %dir /var/ftp
%attr(2555,ftp,ftp) %dir /var/ftp/pub
%attr(700,root,root) %dir %{_sysconfdir}/vsftpd
%config(noreplace) %{_sysconfdir}/vsftpd/*
%config(noreplace) %{_sysconfdir}/pam.d/vsftpd
%config(noreplace) %{_sysconfdir}/logrotate.d/vsftpd
%{_mandir}/*/*

%changelog
* Sun Jun 12 2005 Per Øyvind Karlsen <pkarlsen@mandriva.com> 2.0.3-1mdk
- 2.0.3
- compile with $RPM_OPT_FLAGS
- fix executable-marked-as-config-file
- %%mkrel

* Wed Mar  9 2005 Daouda LO <daouda@mandrakesoft.com> 2.0.2-3mdk
 o Wed Mar  9 2005 Daouda LO <daouda@mandrakesoft.com> 2.0.2-2mdk
   - s/vsftpd/proftpd/ in post_service 

 o Wed Mar  9 2005 Daouda LO <daouda@mandrakesoft.com> 2.0.2-1mdk
  - 2.0.2
  - import fedora patches
   x use xferlog for upload/download logging
   x build with tcp_wrappers, pam and ssl support
   x mv all conf file to /etc/vsftpd.conf
   x standalone vsftpd init script
   x ship with migration script
  - mv xinetd file to docdir

* Sat Nov 13 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.0.1-3mdk
- fix buildrequires

* Mon Oct 11 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.0.1-2mdk
- put back lib64 fix erroneously removed from last release

* Mon Jul 26 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.0.1-1mdk
- 2.0.1
- drop P0 (fixed upstream)
- cosmetics

* Tue Apr 27 2004 Guillaume Rousse <guillomovitch@mandrake.org> 1.2.2-1mdk
- macros
- removed redundant requires
- Anne Nicolas <ennael@mandrake.org> 
 - release 1.2.2 (bug fixes)
 - fix unstability under extreme load

* Mon Nov 24 2003 Daouda LO <daouda@mandrakesoft.com> 1.2.1-1mdk
- release 1.2.1 (bug fixes)

* Wed Apr 23 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.2.0-2mdk
- Add more Conflicts: pure-ftpd ncftpd
- Patch4: Use normal link command for pam injection

* Tue Jan 14 2003 Damien Chaumette <dchaumette@mandrakesoft.com> 1.2.0-1mdk
- 1.2.0 version

* Tue Oct 15 2002 Damien Chaumette <dchaumette@mandrakesoft.com> 1.1.1-1mdk
- 1.1.1 version

* Sun May 26 2002 Yves Duret <yduret@mandrakesoft.com> 1.0.1-1mdk
- first mandrake version
